diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java b/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
index 30410ce3c..844e1d42b 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
+++ b/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
@@ -6,6 +6,7 @@ package net.minecraft.core.item.block;
 
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockFluid;
 import net.minecraft.core.block.BlockLayerBase;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.EntityPlayer;
@@ -15,6 +16,8 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
+import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
+
 
 public class ItemBlockLayer extends ItemBlock
 {
@@ -24,7 +27,7 @@ public class ItemBlockLayer extends ItemBlock
 	}
 
 	@Override
-	public boolean onItemUse(final ItemStack itemstack, final EntityPlayer entityplayer, final World world, int blockX, int blockY, int blockZ, final Side side, double xPlaced, final double yPlaced)
+	public boolean onUseItemOnBlock(final ItemStack itemstack, final EntityPlayer entityplayer, final World world, int blockX, int blockY, int blockZ, final Side side, double xPlaced, final double yPlaced)
 	{
 		int id = world.getBlockId(blockX, blockY, blockZ);
 		int meta = world.getBlockMetadata(blockX, blockY, blockZ);
@@ -126,11 +129,11 @@ public class ItemBlockLayer extends ItemBlock
 		{
 			final Block block = Block.blocksList[blockID];
 			Block currentBlock = world.getBlock(blockX, blockY, blockZ);
-			boolean placedInside = currentBlock != null;
+			boolean placedInside = currentBlock != null && !(currentBlock instanceof BlockFluid);
 			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, getPlacedBlockMetadata(itemstack.getMetadata())))
 			{
 				if (placedInside && !world.isClientSide){
-					world.playSoundEffect(2001, blockX, blockY, blockZ, currentBlock.id);
+					world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, currentBlock.id);
 				}
 				Block.blocksList[blockID].onBlockPlaced(world, blockX, blockY, blockZ, null, entityplayer, yPlaced);
 				world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java b/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
index 3057c289d..43f001ff3 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
+++ b/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
@@ -4,6 +4,7 @@ package net.minecraft.core.item.block;
 
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockFluid;
 import net.minecraft.core.block.BlockLayerBase;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.EntityPlayer;
@@ -13,6 +14,8 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
+import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
+
 public class ItemBlockLayerLeaves extends ItemBlock
 {
 	public ItemBlockLayerLeaves(Block block)
@@ -21,7 +24,7 @@ public class ItemBlockLayerLeaves extends ItemBlock
 	}
 
 	@Override
-	public boolean onItemUse(final ItemStack itemstack, final EntityPlayer entityplayer, final World world, int blockX, int blockY, int blockZ, final Side side, double xPlaced, final double yPlaced)
+	public boolean onUseItemOnBlock(final ItemStack itemstack, final EntityPlayer entityplayer, final World world, int blockX, int blockY, int blockZ, final Side side, double xPlaced, final double yPlaced)
 	{
 		int id = world.getBlockId(blockX, blockY, blockZ);
 		int meta = world.getBlockMetadata(blockX, blockY, blockZ);
@@ -123,11 +126,11 @@ public class ItemBlockLayerLeaves extends ItemBlock
 		{
 			final Block block = Block.blocksList[blockID];
 			Block currentBlock = world.getBlock(blockX, blockY, blockZ);
-			boolean placedInside = currentBlock != null;
+			boolean placedInside = currentBlock != null && !(currentBlock instanceof BlockFluid);
 			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, getPlacedBlockMetadata(itemstack.getMetadata())))
 			{
 				if (placedInside && !world.isClientSide){
-					world.playSoundEffect(2001, blockX, blockY, blockZ, currentBlock.id);
+					world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, currentBlock.id);
 				}
 				Block.blocksList[blockID].onBlockPlaced(world, blockX, blockY, blockZ, null, entityplayer, yPlaced);
 				world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java b/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
index 115984e3b..f5f72bd45 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
+++ b/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
@@ -2,6 +2,7 @@ package net.minecraft.core.item.block;
 
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockFluid;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
@@ -10,6 +11,8 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
+import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
+
 
 // Referenced classes of package net.minecraft.src:
 //            Item, Block, World, ItemStack, 
@@ -24,7 +27,7 @@ public class ItemBlockSlab extends ItemBlock
     }
 
     @Override
-    public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
     	int id = world.getBlockId(blockX, blockY, blockZ);
     	int meta = world.getBlockMetadata(blockX, blockY, blockZ) & 0x3;
@@ -93,11 +96,11 @@ public class ItemBlockSlab extends ItemBlock
         {
             Block block = Block.blocksList[blockID];
             Block currentBlock = world.getBlock(blockX, blockY, blockZ);
-            boolean placedInside = currentBlock != null;
+            boolean placedInside = currentBlock != null && !(currentBlock instanceof BlockFluid);
             if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, getPlacedBlockMetadata(itemstack.getMetadata())))
             {
                 if (placedInside && !world.isClientSide){
-                    world.playSoundEffect(2001, blockX, blockY, blockZ, currentBlock.id);
+                    world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, currentBlock.id);
                 }
             	Block.blocksList[blockID].onBlockPlaced(world, blockX, blockY, blockZ, side, entityplayer, yPlaced);
                 world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
diff --git a/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java b/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
index 6a205e810..e56d26f74 100644
--- a/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
+++ b/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
@@ -31,7 +31,7 @@ public class ItemToolHoe extends ItemTool
     }
 
     @Override
-    public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         int id = world.getBlockId(blockX, blockY, blockZ);
         int j1 = world.getBlockId(blockX, blockY + 1, blockZ);
diff --git a/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java b/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
index d92026e05..61037b618 100644
--- a/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
+++ b/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
@@ -27,7 +27,7 @@ public class ItemToolShovel extends ItemTool
     }
 
     @Override
-    public boolean onItemUse(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         int i1 = world.getBlockId(blockX, blockY, blockZ);
         int j1 = world.getBlockId(blockX, blockY + 1, blockZ);
diff --git a/src/main/java/net/minecraft/core/net/entity/INetworkEntry.java b/src/main/java/net/minecraft/core/net/entity/INetworkEntry.java
new file mode 100644
index 000000000..51a23f9f9
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/entity/INetworkEntry.java
@@ -0,0 +1,8 @@
+package net.minecraft.core.net.entity;
+
+import org.jetbrains.annotations.NotNull;
+
+public interface INetworkEntry<T> {
+    @NotNull
+    Class<? extends T> getAppliedClass();
+}
diff --git a/src/main/java/net/minecraft/core/net/entity/IPacketEntry.java b/src/main/java/net/minecraft/core/net/entity/IPacketEntry.java
new file mode 100644
index 000000000..71870482e
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/entity/IPacketEntry.java
@@ -0,0 +1,8 @@
+package net.minecraft.core.net.entity;
+
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.server.entity.EntityTrackerEntry;
+
+public interface IPacketEntry<T> extends INetworkEntry<T> {
+    Packet getSpawnPacket(EntityTrackerEntry tracker, T trackedObject);
+}
diff --git a/src/main/java/net/minecraft/core/net/entity/ITrackedEntry.java b/src/main/java/net/minecraft/core/net/entity/ITrackedEntry.java
new file mode 100644
index 000000000..31786c2ec
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/entity/ITrackedEntry.java
@@ -0,0 +1,11 @@
+package net.minecraft.core.net.entity;
+
+import net.minecraft.server.entity.EntityTracker;
+import net.minecraft.server.entity.EntityTrackerEntry;
+
+public interface ITrackedEntry<T> extends INetworkEntry<T> {
+    int getTrackingDistance();
+    int getPacketDelay();
+    boolean sendMotionUpdates();
+    void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, T trackedObject);
+}
diff --git a/src/main/java/net/minecraft/core/net/entity/IVehicleEntry.java b/src/main/java/net/minecraft/core/net/entity/IVehicleEntry.java
new file mode 100644
index 000000000..ca2eca917
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/entity/IVehicleEntry.java
@@ -0,0 +1,11 @@
+package net.minecraft.core.net.entity;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.net.packet.Packet23VehicleSpawn;
+import net.minecraft.core.world.World;
+import net.minecraft.server.entity.EntityTrackerEntry;
+
+public interface IVehicleEntry<T> extends IPacketEntry<T> {
+    Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner);
+    Packet23VehicleSpawn getSpawnPacket(EntityTrackerEntry tracker, T trackedObject);
+}
diff --git a/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java b/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
new file mode 100644
index 000000000..1f32af28f
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
@@ -0,0 +1,152 @@
+package net.minecraft.core.net.entity;
+
+import net.minecraft.core.net.entity.entries.AnimalNetEntry;
+import net.minecraft.core.net.entity.entries.ArrowNetEntry;
+import net.minecraft.core.net.entity.entries.BoatNetEntry;
+import net.minecraft.core.net.entity.entries.BobberEntry;
+import net.minecraft.core.net.entity.entries.CannonballEntry;
+import net.minecraft.core.net.entity.entries.EggNetEntry;
+import net.minecraft.core.net.entity.entries.FallingSandNetEntry;
+import net.minecraft.core.net.entity.entries.FireballNetEntry;
+import net.minecraft.core.net.entity.entries.FireflyNetEntry;
+import net.minecraft.core.net.entity.entries.ItemNetEntry;
+import net.minecraft.core.net.entity.entries.MinecartNetEntry;
+import net.minecraft.core.net.entity.entries.PaintingNetEntry;
+import net.minecraft.core.net.entity.entries.PebbleEntry;
+import net.minecraft.core.net.entity.entries.PlayerMPNetEntry;
+import net.minecraft.core.net.entity.entries.SnowballNetEntry;
+import net.minecraft.core.net.entity.entries.SquidNetEntry;
+import net.minecraft.core.net.entity.entries.TNTNetEntry;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.net.packet.Packet23VehicleSpawn;
+import net.minecraft.server.entity.EntityTrackerEntry;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.ArrayList;
+import java.util.Comparator;
+import java.util.HashMap;
+import java.util.LinkedHashMap;
+import java.util.List;
+import java.util.Map;
+
+public class NetEntityHandler {
+    private static final Map<Class<?>, INetworkEntry<?>> entryClassMap = new LinkedHashMap<>();
+    private static final List<INetworkEntry<?>> netEntries = new ArrayList<>();
+    private static final List<IPacketEntry<?>> packetEntries = new ArrayList<>();
+    private static final List<ITrackedEntry<?>> trackedEntries = new ArrayList<>();
+    private static final Map<Integer, IVehicleEntry<?>> typeToProviderMap = new HashMap<>();
+    private static final Map<IVehicleEntry<?>, Integer> providerToTypeMap = new HashMap<>();
+    private static boolean isListDirty = false;
+    public static <T> void registerNetworkEntry(INetworkEntry<T> networkEntity){
+        addEntryRaw(networkEntity, -1);
+    }
+    public static <T> void registerNetworkEntry(IVehicleEntry<T> typedEntity, int type){
+        addEntryRaw(typedEntity, type);
+    }
+    private static <T> void addEntryRaw(INetworkEntry<T> entry, int type){
+        Class<? extends T> entityClass = entry.getAppliedClass();
+        if (entryClassMap.containsKey(entityClass)){
+            INetworkEntry<?> previousEntry = entryClassMap.get(entityClass);
+            netEntries.remove(previousEntry);
+            packetEntries.remove(previousEntry);
+            trackedEntries.remove(previousEntry);
+
+            entryClassMap.remove(entityClass);
+
+            if (type >= 0 && typeToProviderMap.containsKey(type)){
+                providerToTypeMap.remove(typeToProviderMap.remove(type));
+            }
+        }
+        entryClassMap.put(entityClass, entry);
+        netEntries.add(entry);
+
+        if (type >= 0 && entry instanceof IVehicleEntry){
+            typeToProviderMap.put(type, (IVehicleEntry<?>) entry);
+            providerToTypeMap.put((IVehicleEntry<?>) entry, type);
+        }
+
+        if (entry instanceof IPacketEntry){
+            packetEntries.add((IPacketEntry<?>) entry);
+        }
+
+        if (entry instanceof ITrackedEntry){
+            trackedEntries.add((ITrackedEntry<?>) entry);
+        }
+
+        isListDirty = true;
+    }
+
+    @SuppressWarnings("unchecked") // I sign off on this check :)
+    public static Packet getSpawnPacket(@NotNull EntityTrackerEntry trackerEntry) {
+        if (isListDirty){
+            sortEntries();
+        }
+        for (IPacketEntry netEnt : packetEntries){
+            if (netEnt.getAppliedClass().isAssignableFrom(trackerEntry.trackedEntity.getClass())){
+                Packet packet;
+                if (netEnt instanceof IVehicleEntry){
+                    packet = ((IVehicleEntry)netEnt).getSpawnPacket(trackerEntry, trackerEntry.trackedEntity).setType(providerToTypeMap.get(netEnt));
+                } else {
+                    packet = netEnt.getSpawnPacket(trackerEntry, trackerEntry.trackedEntity);
+                }
+                return packet;
+            }
+        }
+        throw new IllegalArgumentException("Don't know how to add " + trackerEntry.trackedEntity.getClass() + "!");
+    }
+    @SuppressWarnings("unchecked")
+    public static <T> ITrackedEntry<T> getTrackedEntry(T entity){
+        if (isListDirty){
+            sortEntries();
+        }
+        for (ITrackedEntry tracked : trackedEntries){
+            if (tracked.getAppliedClass().isAssignableFrom(entity.getClass())){
+                return tracked;
+            }
+        }
+        return null;
+    }
+
+    public static boolean hasType(int type){
+        return typeToProviderMap.containsKey(type);
+    }
+    public static IVehicleEntry<?> getTypeEntry(int type){
+        return typeToProviderMap.get(type);
+    }
+    private static void sortEntries(){
+        Comparator<INetworkEntry<?>> networkEntryComparator = (o1, o2) -> {
+            if (o1.getAppliedClass().isAssignableFrom(o2.getAppliedClass())) return  1;
+            if (o2.getAppliedClass().isAssignableFrom(o1.getAppliedClass())) return -1;
+            return o1.getAppliedClass().getSimpleName().compareTo(o2.getAppliedClass().getSimpleName());
+        };
+        // Sort Higher level classes to the bottom of the list, and base classes to the top, so that base level classes don't "shadow" higher level entries
+        netEntries.sort(networkEntryComparator);
+        packetEntries.sort(networkEntryComparator);
+        trackedEntries.sort(networkEntryComparator);
+        isListDirty = false;
+    }
+
+    static {
+        registerNetworkEntry(new AnimalNetEntry<>());
+        registerNetworkEntry(new SquidNetEntry());
+        registerNetworkEntry(new FireflyNetEntry());
+        registerNetworkEntry(new ItemNetEntry());
+        registerNetworkEntry(new PaintingNetEntry());
+        registerNetworkEntry(new PlayerMPNetEntry());
+
+        registerNetworkEntry(new ArrowNetEntry(), 1);
+        registerNetworkEntry(new CannonballEntry(), 2);
+        registerNetworkEntry(new EggNetEntry(), 3);
+        registerNetworkEntry(new FireballNetEntry(), 4);
+        registerNetworkEntry(new PebbleEntry(), 5);
+        registerNetworkEntry(new SnowballNetEntry(), 6);
+
+        registerNetworkEntry(new BoatNetEntry(), 10);
+        registerNetworkEntry(new MinecartNetEntry(), 11);
+
+        registerNetworkEntry(new FallingSandNetEntry(), 20);
+        registerNetworkEntry(new TNTNetEntry(), 21);
+
+        registerNetworkEntry(new BobberEntry(), 30);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/AnimalNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/AnimalNetEntry.java
new file mode 100644
index 000000000..c512115ad
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/entity/entries/AnimalNetEntry.java
@@ -0,0 +1,43 @@
+package net.minecraft.core.net.entity.entries;
+
+import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.animal.IAnimal;
+import net.minecraft.core.net.entity.IPacketEntry;
+import net.minecraft.core.net.entity.ITrackedEntry;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.net.packet.Packet24MobSpawn;
+import net.minecraft.server.entity.EntityTracker;
+import net.minecraft.server.entity.EntityTrackerEntry;
+import org.jetbrains.annotations.NotNull;
+
+public class AnimalNetEntry<T extends IAnimal> implements IPacketEntry<T>, ITrackedEntry<T> {
+    @Override
+    public @NotNull Class<T> getAppliedClass() {
+        return (Class<T>) IAnimal.class;
+    }
+
+    @Override
+    public int getTrackingDistance() {
+        return 160;
+    }
+
+    @Override
+    public int getPacketDelay() {
+        return 3;
+    }
+
+    @Override
+    public boolean sendMotionUpdates() {
+        return false;
+    }
+
+    @Override
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, IAnimal trackedObject) {
+
+    }
+
+    @Override
+    public Packet getSpawnPacket(EntityTrackerEntry tracker, IAnimal trackedObject) {
+        return new Packet24MobSpawn((EntityLiving) trackedObject);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/ArrowNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/ArrowNetEntry.java
new file mode 100644
index 000000000..2e025486c
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/entity/entries/ArrowNetEntry.java
@@ -0,0 +1,61 @@
+package net.minecraft.core.net.entity.entries;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.projectile.EntityArrow;
+import net.minecraft.core.entity.projectile.EntityArrowGolden;
+import net.minecraft.core.entity.projectile.EntityArrowPurple;
+import net.minecraft.core.net.entity.ITrackedEntry;
+import net.minecraft.core.net.entity.IVehicleEntry;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.net.packet.Packet23VehicleSpawn;
+import net.minecraft.core.world.World;
+import net.minecraft.server.entity.EntityTracker;
+import net.minecraft.server.entity.EntityTrackerEntry;
+import org.jetbrains.annotations.NotNull;
+
+public class ArrowNetEntry implements IVehicleEntry<EntityArrow>, ITrackedEntry<EntityArrow> {
+    @Override
+    public @NotNull Class<EntityArrow> getAppliedClass() {
+        return EntityArrow.class;
+    }
+
+    @Override
+    public int getTrackingDistance() {
+        return 64;
+    }
+
+    @Override
+    public int getPacketDelay() {
+        return 20;
+    }
+
+    @Override
+    public boolean sendMotionUpdates() {
+        return false;
+    }
+
+    @Override
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, EntityArrow trackedObject) {
+
+    }
+
+    @Override
+    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
+        if (metadata == 2) {
+            return new EntityArrowGolden(world, x, y, z);
+        } else if (metadata == 1) {
+            return new EntityArrowPurple(world, x, y, z);
+        } else {
+            return new EntityArrow(world, x, y, z, metadata);
+        }
+    }
+
+    @Override
+    public Packet23VehicleSpawn getSpawnPacket(EntityTrackerEntry tracker, EntityArrow trackedObject) {
+        EntityLiving entityliving = trackedObject.owner;
+        return new Packet23VehicleSpawn(trackedObject,
+            trackedObject.getArrowType(), entityliving == null ? -1 : entityliving.id,
+            trackedObject.xd, trackedObject.yd, trackedObject.zd);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/BoatNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/BoatNetEntry.java
new file mode 100644
index 000000000..5dae1d34e
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/entity/entries/BoatNetEntry.java
@@ -0,0 +1,49 @@
+package net.minecraft.core.net.entity.entries;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.vehicle.EntityBoat;
+import net.minecraft.core.net.entity.ITrackedEntry;
+import net.minecraft.core.net.entity.IVehicleEntry;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.net.packet.Packet23VehicleSpawn;
+import net.minecraft.core.world.World;
+import net.minecraft.server.entity.EntityTracker;
+import net.minecraft.server.entity.EntityTrackerEntry;
+import org.jetbrains.annotations.NotNull;
+
+public class BoatNetEntry implements IVehicleEntry<EntityBoat>, ITrackedEntry<EntityBoat> {
+    @Override
+    public @NotNull Class<EntityBoat> getAppliedClass() {
+        return EntityBoat.class;
+    }
+
+    @Override
+    public int getTrackingDistance() {
+        return 160;
+    }
+
+    @Override
+    public int getPacketDelay() {
+        return 1;
+    }
+
+    @Override
+    public boolean sendMotionUpdates() {
+        return true;
+    }
+
+    @Override
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, EntityBoat trackedObject) {
+
+    }
+
+    @Override
+    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
+        return new EntityBoat(world, x, y, z);
+    }
+
+    @Override
+    public Packet23VehicleSpawn getSpawnPacket(EntityTrackerEntry tracker, EntityBoat trackedObject) {
+        return new Packet23VehicleSpawn(trackedObject);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/BobberEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/BobberEntry.java
new file mode 100644
index 000000000..77cce06c3
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/entity/entries/BobberEntry.java
@@ -0,0 +1,49 @@
+package net.minecraft.core.net.entity.entries;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityBobber;
+import net.minecraft.core.net.entity.ITrackedEntry;
+import net.minecraft.core.net.entity.IVehicleEntry;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.net.packet.Packet23VehicleSpawn;
+import net.minecraft.core.world.World;
+import net.minecraft.server.entity.EntityTracker;
+import net.minecraft.server.entity.EntityTrackerEntry;
+import org.jetbrains.annotations.NotNull;
+
+public class BobberEntry implements IVehicleEntry<EntityBobber>, ITrackedEntry<EntityBobber> {
+    @Override
+    public @NotNull Class<EntityBobber> getAppliedClass() {
+        return EntityBobber.class;
+    }
+
+    @Override
+    public int getTrackingDistance() {
+        return 64;
+    }
+
+    @Override
+    public int getPacketDelay() {
+        return 5;
+    }
+
+    @Override
+    public boolean sendMotionUpdates() {
+        return true;
+    }
+
+    @Override
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, EntityBobber trackedObject) {
+
+    }
+
+    @Override
+    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
+        return new EntityBobber(world, x, y, z);
+    }
+
+    @Override
+    public Packet23VehicleSpawn getSpawnPacket(EntityTrackerEntry tracker, EntityBobber trackedObject) {
+        return new Packet23VehicleSpawn(trackedObject);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/CannonballEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/CannonballEntry.java
new file mode 100644
index 000000000..b6c80012b
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/entity/entries/CannonballEntry.java
@@ -0,0 +1,53 @@
+package net.minecraft.core.net.entity.entries;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.projectile.EntityCannonball;
+import net.minecraft.core.net.entity.ITrackedEntry;
+import net.minecraft.core.net.entity.IVehicleEntry;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.net.packet.Packet23VehicleSpawn;
+import net.minecraft.core.world.World;
+import net.minecraft.server.entity.EntityTracker;
+import net.minecraft.server.entity.EntityTrackerEntry;
+import org.jetbrains.annotations.NotNull;
+
+public class CannonballEntry implements IVehicleEntry<EntityCannonball>, ITrackedEntry<EntityCannonball> {
+    @Override
+    public @NotNull Class<EntityCannonball> getAppliedClass() {
+        return EntityCannonball.class;
+    }
+
+    @Override
+    public int getTrackingDistance() {
+        return 64;
+    }
+
+    @Override
+    public int getPacketDelay() {
+        return 10;
+    }
+
+    @Override
+    public boolean sendMotionUpdates() {
+        return false;
+    }
+
+    @Override
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, EntityCannonball trackedObject) {
+
+    }
+
+    @Override
+    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
+        return new EntityCannonball(world, x, y, z);
+    }
+
+    @Override
+    public Packet23VehicleSpawn getSpawnPacket(EntityTrackerEntry tracker, EntityCannonball trackedObject) {
+        EntityLiving entityliving = trackedObject.owner;
+        return new Packet23VehicleSpawn(trackedObject, -1,
+            entityliving == null ? -1 : entityliving.id,
+            trackedObject.xd, trackedObject.yd, trackedObject.zd);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/EggNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/EggNetEntry.java
new file mode 100644
index 000000000..0f28b1408
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/entity/entries/EggNetEntry.java
@@ -0,0 +1,49 @@
+package net.minecraft.core.net.entity.entries;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.projectile.EntityEgg;
+import net.minecraft.core.net.entity.ITrackedEntry;
+import net.minecraft.core.net.entity.IVehicleEntry;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.net.packet.Packet23VehicleSpawn;
+import net.minecraft.core.world.World;
+import net.minecraft.server.entity.EntityTracker;
+import net.minecraft.server.entity.EntityTrackerEntry;
+import org.jetbrains.annotations.NotNull;
+
+public class EggNetEntry implements IVehicleEntry<EntityEgg>, ITrackedEntry<EntityEgg> {
+    @Override
+    public @NotNull Class<EntityEgg> getAppliedClass() {
+        return EntityEgg.class;
+    }
+
+    @Override
+    public int getTrackingDistance() {
+        return 64;
+    }
+
+    @Override
+    public int getPacketDelay() {
+        return 10;
+    }
+
+    @Override
+    public boolean sendMotionUpdates() {
+        return true;
+    }
+
+    @Override
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, EntityEgg trackedObject) {
+
+    }
+
+    @Override
+    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
+        return new EntityEgg(world, x, y, z);
+    }
+
+    @Override
+    public Packet23VehicleSpawn getSpawnPacket(EntityTrackerEntry tracker, EntityEgg trackedObject) {
+        return new Packet23VehicleSpawn(trackedObject);
+    }
+}
